//memory.cpp
//RAND_MAX=32767

//  Spielfeld:

//  A1 A2 A3 A4
//  B1 B2 B3 B4
//  C1 C2 C3 C4
//  D1 D2 D3 D4


#include "stdafx.h"
#include "memory.h"
#include "resource.h"
#include "AboutDialog.h"
#include "Help.h"

BEGIN_MESSAGE_MAP(CGrafikWindow,CFrameWnd)				
		ON_WM_LBUTTONDOWN()	
		ON_WM_LBUTTONUP()	
		ON_WM_RBUTTONDOWN()	
		ON_WM_MOUSEMOVE()
		ON_WM_TIMER()		
		ON_WM_PAINT()
		ON_COMMAND(ID_HELP_ABOUT, OnAbout)
		ON_COMMAND(ID_HELP_TUTORIAL, OnTutorial)
		ON_COMMAND(ID_GAME_NEWGAME, OnNewGame)
		ON_COMMAND(ID_GAME_EXIT, OnQuit)

		ON_COMMAND(ID_OPTIONS_ANIMALS, OnAnimals)		
		ON_COMMAND(ID_OPTIONS_TRAFFIC, OnTraffic)
		ON_COMMAND(ID_OPTIONS_COLORS, OnColors)	
		
		ON_COMMAND(ID_OPTIONS_FRUITS, OnFruits)
		ON_COMMAND(ID_OPTIONS_ORIENTAL, OnOriental)
		ON_COMMAND(ID_OPTIONS_CARTOONS, OnCartoons)
		ON_COMMAND(ID_OPTIONS_CHRISTMAS, OnChristmas)
		ON_COMMAND(ID_OPTIONS_OBJECTS, OnObjects)
		ON_COMMAND(ID_OPTIONS_SIGNS, OnSigns)
		ON_COMMAND(ID_OPTIONS_SHUFFLE, OnShuffle)
END_MESSAGE_MAP()


CGrafikApp::CGrafikApp()
{
	cgw=0;
}

BOOL CGrafikApp::InitInstance()
{
CBrush bkbrush;
bkbrush.CreateStockObject(WHITE_BRUSH);

LPCSTR cname= AfxRegisterWndClass(0,LoadCursor(IDC_HAND),bkbrush,LoadIcon(IDI_ICON1));
m_pMainWnd = new CGrafikWindow(cname);
m_pMainWnd->ShowWindow(m_nCmdShow);
m_pMainWnd->UpdateWindow();

return TRUE;
}


CGrafikWindow::~CGrafikWindow()
{		
	dcBack.DeleteDC();
	dcTile.DeleteDC();
	dcTemp.DeleteDC();
	dcTitle.DeleteDC();
	backbmp.DeleteObject();
	tilebmp.DeleteObject();
	tempbmp.DeleteObject();
	titlebmp.DeleteObject();
	redPen.DeleteObject();
	nullBrush.DeleteObject();
}

void CGrafikWindow::OnPaint()
{	
	drawGraphics();
	CFrameWnd::OnPaint();
}

void CGrafikWindow::OnMouseMove( UINT nFlags, CPoint point )
{		
	int x=point.x;
	int y=point.y;

	if(x>0&&x<70&&y>0&&y<70)		hilite=1;
	if(x>70&&x<140&&y>0&&y<70)		hilite=2;
	if(x>140&&x<210&&y>0&&y<70)		hilite=3;
	if(x>210&&x<280&&y>0&&y<70)		hilite=4;

	if(x>0&&x<70&&y>70&&y<141)		hilite=5;
	if(x>70&&x<140&&y>70&&y<140)	hilite=6;
	if(x>140&&x<210&&y>70&&y<140)	hilite=7;
	if(x>210&&x<280&&y>70&&y<140)	hilite=8;

	if(x>0&&x<70&&y>140&&y<210)		hilite=9;
	if(x>70&&x<140&&y>140&&y<210)	hilite=10;
	if(x>140&&x<210&&y>140&&y<210)	hilite=11;
	if(x>210&&x<280&&y>140&&y<210)	hilite=12;

	if(x>0&&x<70&&y>210&&y<280)		hilite=13;
	if(x>70&&x<140&&y>210&&y<280)	hilite=14;
	if(x>140&&x<210&&y>210&&y<280)	hilite=15;
	if(x>210&&x<280&&y>210&&y<280)	hilite=16;	

	if(x>270||x<10||y>270||y<10)	hilite=0;
}

void CGrafikWindow::OnLButtonUp(UINT nFlags, CPoint point)
{		
	mousedown=false;
}

void CGrafikWindow::OnLButtonDown(UINT nFlags, CPoint point)
{	
	if(intro==false)
	{
	klicked=true;
	mousedown=true;

	int x=point.x;
	int y=point.y;

//////////////////Klick auf aufgedeckte Felder ignorieren/////////

	if((x>0&&x<=70&&y>0&&y<=70&&A1==true )||
	(x>70&&x<=140&&y>0&&y<=70&&A2==true)||
	(x>140&&x<=210&&y>0&&y<=70&&A3==true)||
	(x>210&&x<=280&&y>0&&y<=70&&A4==true)||

	(x>0&&x<=70&&y>70&&y<=140&&B1==true)||
	(x>70&&x<=140&&y>70&&y<=140&&B2==true)||
	(x>140&&x<=210&&y>70&&y<=140&&B3==true)||
	(x>210&&x<=280&&y>70&&y<=140&&B4==true)||

	(x>0&&x<=70&&y>140&&y<=210&&C1==true)||
	(x>70&&x<=140&&y>140&&y<=210&&C2==true)||
	(x>140&&x<=210&&y>140&&y<=210&&C3==true)||
	(x>210&&x<=280&&y>140&&y<=210&&C4==true)||

	(x>0&&x<=70&&y>210&&y<=280&&D1==true)||
	(x>70&&x<=140&&y>210&&y<=280&&D2==true)||
	(x>140&&x<=210&&y>210&&y<=280&&D3==true)||
	(x>210&&x<=280&&y>210&&y<=280&&D4==true))

		m_Status.SetText("False Move",2,0);
	else
	{
		m_Status.SetText("",2,0);
////////////////////////////////////////////////////////////////////
	
	if(clickSequence<4)clickSequence++; 
	if(clickSequence>3)clickSequence=1;		

if(clickSequence==1)
{
	m_Status.SetText("Tile 1",1,0);

	if(x>0&&x<=70&&y>0&&y<=70){a1=true;		val1=matrix[0];	m1=1;}
	if(x>70&&x<=140&&y>0&&y<=70){a2=true;		val1=matrix[1]; m1=2;}
	if(x>140&&x<=210&&y>0&&y<=70){a3=true;	val1=matrix[2];	m1=3;}
	if(x>210&&x<=280&&y>0&&y<=70){a4=true;	val1=matrix[3];	m1=4;}

	if(x>0&&x<=70&&y>70&&y<=140){b1=true;		val1=matrix[4];	m1=5;}
	if(x>70&&x<=140&&y>70&&y<=140){b2=true;	val1=matrix[5];	m1=6;}
	if(x>140&&x<=210&&y>70&&y<=140){b3=true;	val1=matrix[6];	m1=7;}
	if(x>210&&x<=280&&y>70&&y<=140){b4=true;	val1=matrix[7];	m1=8;}

	if(x>0&&x<=70&&y>140&&y<=210){c1=true;	val1=matrix[8];	m1=9;}
	if(x>70&&x<=140&&y>140&&y<=210){c2=true;	val1=matrix[9];	m1=10;}
	if(x>140&&x<=210&&y>140&&y<=210){c3=true;	val1=matrix[10];m1=11;}
	if(x>210&&x<=280&&y>140&&y<=210){c4=true;	val1=matrix[11];m1=12;}

	if(x>0&&x<=70&&y>210&&y<=280){d1=true;	val1=matrix[12];m1=13;}
	if(x>70&&x<=140&&y>210&&y<=280){d2=true;	val1=matrix[13];m1=14;}
	if(x>140&&x<=210&&y>210&&y<=280){d3=true;	val1=matrix[14];m1=15;}
	if(x>210&&x<=280&&y>210&&y<=280){d4=true;	val1=matrix[15];m1=16;}
}

else if(clickSequence==2)
{
	m_Status.SetText("Tile 2",1,0);
	errors++;

	if(x>0&&x<=70&&y>0&&y<=70){a1=true;		val2=matrix[0];	m2=1;}
	if(x>70&&x<=140&&y>0&&y<=70){a2=true;		val2=matrix[1];	m2=2;}
	if(x>140&&x<=210&&y>0&&y<=70){a3=true;	val2=matrix[2];	m2=3;}
	if(x>210&&x<=280&&y>0&&y<=70){a4=true;	val2=matrix[3];	m2=4;}

	if(x>0&&x<=70&&y>70&&y<=140){b1=true;		val2=matrix[4];	m2=5;}
	if(x>70&&x<=140&&y>70&&y<=140){b2=true;	val2=matrix[5];	m2=6;}
	if(x>140&&x<=210&&y>70&&y<=140){b3=true;	val2=matrix[6];	m2=7;}
	if(x>210&&x<=280&&y>70&&y<=140){b4=true;	val2=matrix[7];	m2=8;}

	if(x>0&&x<=70&&y>140&&y<=210){c1=true;	val2=matrix[8];	m2=9;}
	if(x>70&&x<=140&&y>140&&y<=210){c2=true;	val2=matrix[9];	m2=10;}
	if(x>140&&x<=210&&y>140&&y<=210){c3=true;	val2=matrix[10];m2=11;}
	if(x>210&&x<=280&&y>140&&y<=210){c4=true;	val2=matrix[11];m2=12;}

	if(x>0&&x<=70&&y>210&&y<=280){d1=true;	val2=matrix[12];m2=13;}
	if(x>70&&x<=140&&y>210&&y<=280){d2=true;	val2=matrix[13];m2=14;}
	if(x>140&&x<=210&&y>210&&y<=280){d3=true;	val2=matrix[14];m2=15;}
	if(x>210&&x<=280&&y>210&&y<=280){d4=true;	val2=matrix[15];m2=16;}

	if(m2==m1)//zweimal aufs gleiche Feld geklickt
	{
		if(m1==1){a1=false;A1=false;}
		if(m1==2){a2=false;A2=false;}
		if(m1==3){a3=false;A3=false;}
		if(m1==4){a4=false;A4=false;}

		if(m1==5){b1=false;B1=false;}
		if(m1==6){b2=false;B2=false;}
		if(m1==7){b3=false;B3=false;}
		if(m1==8){b4=false;B4=false;}

		if(m1==9){c1=false;C1=false;}
		if(m1==10){c2=false;C2=false;}
		if(m1==11){c3=false;C3=false;}
		if(m1==12){c4=false;C4=false;}

		if(m1==13){d1=false;D1=false;}
		if(m1==14){d2=false;D2=false;}
		if(m1==15){d3=false;D3=false;}
		if(m1==16){d4=false;D4=false;}

		clickSequence=0;
		errors++;
	}
}
	
	}		
	}
}

void CGrafikWindow::OnAnimals()
{	
	dcTemp.SelectObject(&strip[1]);

	CMenu *m_MainMenu = GetMenu();	

	m_MainMenu->CheckMenuItem( ID_OPTIONS_TRAFFIC, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_COLORS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_SIGNS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_ORIENTAL, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_CHRISTMAS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_OBJECTS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_CARTOONS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_FRUITS, MF_UNCHECKED );

	m_MainMenu->CheckMenuItem( ID_OPTIONS_ANIMALS, MF_CHECKED );

	design=2;
}

void CGrafikWindow::OnTraffic()
{	
	dcTemp.SelectObject(&strip[2]);	

	CMenu *m_MainMenu = GetMenu();	
	m_MainMenu->CheckMenuItem( ID_OPTIONS_ANIMALS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_COLORS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_SIGNS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_ORIENTAL, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_CHRISTMAS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_OBJECTS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_CARTOONS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_FRUITS, MF_UNCHECKED );

	m_MainMenu->CheckMenuItem( ID_OPTIONS_TRAFFIC, MF_CHECKED );

	design=3;
}

void CGrafikWindow::OnColors()
{	
	dcTemp.SelectObject(&strip[0]);

	CMenu *m_MainMenu = GetMenu();	

	m_MainMenu->CheckMenuItem( ID_OPTIONS_ANIMALS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_TRAFFIC, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_SIGNS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_ORIENTAL, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_CHRISTMAS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_OBJECTS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_CARTOONS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_FRUITS, MF_UNCHECKED );

	m_MainMenu->CheckMenuItem( ID_OPTIONS_COLORS, MF_CHECKED );

	design=1;
}

void CGrafikWindow::OnSigns()
{	
	dcTemp.SelectObject(&strip[3]);

	CMenu *m_MainMenu = GetMenu();	

	m_MainMenu->CheckMenuItem( ID_OPTIONS_ANIMALS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_COLORS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_TRAFFIC, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_ORIENTAL, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_CHRISTMAS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_OBJECTS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_CARTOONS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_FRUITS, MF_UNCHECKED );

	m_MainMenu->CheckMenuItem( ID_OPTIONS_SIGNS, MF_CHECKED );

	design=4;
}

void CGrafikWindow::OnCartoons()
{	
	dcTemp.SelectObject(&strip[7]);

	CMenu *m_MainMenu = GetMenu();	

	m_MainMenu->CheckMenuItem( ID_OPTIONS_ANIMALS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_COLORS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_TRAFFIC, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_ORIENTAL, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_CHRISTMAS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_OBJECTS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_SIGNS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_FRUITS, MF_UNCHECKED );

	m_MainMenu->CheckMenuItem( ID_OPTIONS_CARTOONS, MF_CHECKED );

	design=8;
}

void CGrafikWindow::OnFruits()
{	
	dcTemp.SelectObject(&strip[8]);

	CMenu *m_MainMenu = GetMenu();	

	m_MainMenu->CheckMenuItem( ID_OPTIONS_ANIMALS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_COLORS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_TRAFFIC, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_ORIENTAL, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_CHRISTMAS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_OBJECTS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_CARTOONS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_SIGNS, MF_UNCHECKED );

	m_MainMenu->CheckMenuItem( ID_OPTIONS_FRUITS, MF_CHECKED );

	design=9;
}

void CGrafikWindow::OnOriental()
{	
	dcTemp.SelectObject(&strip[4]);

	CMenu *m_MainMenu = GetMenu();	

	m_MainMenu->CheckMenuItem( ID_OPTIONS_ANIMALS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_COLORS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_TRAFFIC, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_SIGNS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_CHRISTMAS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_OBJECTS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_CARTOONS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_FRUITS, MF_UNCHECKED );

	m_MainMenu->CheckMenuItem( ID_OPTIONS_ORIENTAL, MF_CHECKED );

	design=5;
}

void CGrafikWindow::OnChristmas()
{	
	dcTemp.SelectObject(&strip[5]);

	CMenu *m_MainMenu = GetMenu();	

	m_MainMenu->CheckMenuItem( ID_OPTIONS_ANIMALS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_COLORS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_TRAFFIC, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_ORIENTAL, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_SIGNS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_OBJECTS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_CARTOONS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_FRUITS, MF_UNCHECKED );

	m_MainMenu->CheckMenuItem( ID_OPTIONS_CHRISTMAS, MF_CHECKED );

	design=6;
}

void CGrafikWindow::OnObjects()
{	
	dcTemp.SelectObject(&strip[6]);

	CMenu *m_MainMenu = GetMenu();	

	m_MainMenu->CheckMenuItem( ID_OPTIONS_ANIMALS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_COLORS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_TRAFFIC, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_ORIENTAL, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_CHRISTMAS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_SIGNS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_CARTOONS, MF_UNCHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_FRUITS, MF_UNCHECKED );

	m_MainMenu->CheckMenuItem( ID_OPTIONS_OBJECTS, MF_CHECKED );

	design=7;
}

void CGrafikWindow::OnShuffle()	
{
	CMenu *m_MainMenu = GetMenu();	

	if(shuffle==true)
	{
		m_MainMenu->CheckMenuItem( ID_OPTIONS_SHUFFLE, MF_UNCHECKED );
		shuffle=false;
	}
	else
	{
		m_MainMenu->CheckMenuItem( ID_OPTIONS_SHUFFLE, MF_CHECKED );
		shuffle=true;
	}
}

void CGrafikWindow::OnRButtonDown(UINT nFlags, CPoint point)
{		
}

void CGrafikWindow::OnTimer(UINT id)
{	

static int introTicker=0;

if(	introTicker<50)
{
	introTicker++;	
}
	else if(introTicker==50)
	{
		InvalidateRect(0);
		introTicker=51;
		intro=false;
	}

	drawGraphics();
}

void CGrafikWindow::OnQuit()
{
	DestroyWindow();
}

void CGrafikWindow::OnNewGame()
{
	endSequence();	
}

void CGrafikWindow::OnAbout()
{	
	CAboutDialog diagOb;
	diagOb.DoModal();
}

void CGrafikWindow::OnTutorial()
{
	CHelp help;
	help.DoModal();	
}


void CGrafikWindow::createMatrix() {								
			
	int c, d;

		

		for (c=0;c<16;c++){					
				//int order = rand()/2050;
				int order = rand()%16;
				//Zufallszahl von 1 bis 16

				matrix[c]=order;				
				if (c>0) {
					for (d=c;d>0;d--){
						if (matrix[c]==matrix[(d-1)])
							c--;											
					}						
				}
		}
}	

void CGrafikWindow::drawTitle()
{
	CClientDC dc(this);	
	dc.BitBlt(0,0,280,306,&dcTitle,0,0,SRCCOPY);	
}

void CGrafikWindow::drawHighlights()
{		
	CClientDC dc(this);	

	dcBack.SelectObject(nullBrush);
	dcBack.SelectObject(redPen);

	if(hilite==1&&a1==false)	dcBack.Rectangle(3,3,66,66);
	if(hilite==2&&a2==false)	dcBack.Rectangle(73,3,136,66);
	if(hilite==3&&a3==false)	dcBack.Rectangle(143,3,206,66);
	if(hilite==4&&a4==false)	dcBack.Rectangle(213,3,276,66);

	if(hilite==5&&b1==false)	dcBack.Rectangle(3,73,66,136);
	if(hilite==6&&b2==false)	dcBack.Rectangle(73,73,136,136);
	if(hilite==7&&b3==false)	dcBack.Rectangle(143,73,206,136);
	if(hilite==8&&b4==false)	dcBack.Rectangle(213,73,276,136);

	if(hilite==9&&c1==false)	dcBack.Rectangle(3,143,66,206);
	if(hilite==10&&c2==false)	dcBack.Rectangle(73,143,136,206);
	if(hilite==11&&c3==false)	dcBack.Rectangle(143,143,206,206);
	if(hilite==12&&c4==false)	dcBack.Rectangle(213,143,276,206);

	if(hilite==13&&d1==false)	dcBack.Rectangle(3,213,66,276);
	if(hilite==14&&d2==false)	dcBack.Rectangle(73,213,136,276);
	if(hilite==15&&d3==false)	dcBack.Rectangle(143,213,206,276);
	if(hilite==16&&d4==false)	dcBack.Rectangle(213,213,276,276);
}	

void CGrafikWindow::initializeNewGame()
{
	createMatrix();
	clickSequence=0;
	errors=0;
	m_Status.SetText("",1,0);
	m_Status.SetText("",2,0);
	a1=a2=a3=a4=b1=b2=b3=b4=c1=c2=c3=c4=d1=d2=d3=d4=false;
	A1=A2=A3=A4=B1=B2=B3=B4=C1=C2=C3=C4=D1=D2=D3=D4=false;
}

void CGrafikWindow::drawTiles()
{			
	CClientDC dc(this);		
	
	for(int i=0;i<16;i++)
	{
	if(matrix[i]>7)
		matrix[i]=matrix[i]-8;	
	}
	

	dcTile.BitBlt(0,0,70,70,&dcTemp,matrix[0]*70,0,SRCCOPY);//welche Kachel?
	dcBack.BitBlt(0,0,70,70,&dcTile,0,0,SRCCOPY);//wohin?	

	dcTile.BitBlt(0,0,70,70,&dcTemp,matrix[1]*70,0,SRCCOPY);
	dcBack.BitBlt(70,0,70,70,&dcTile,0,0,SRCCOPY);

	dcTile.BitBlt(0,0,70,70,&dcTemp,matrix[2]*70,0,SRCCOPY);
	dcBack.BitBlt(140,0,70,70,&dcTile,0,0,SRCCOPY);

	dcTile.BitBlt(0,0,70,70,&dcTemp,matrix[3]*70,0,SRCCOPY);
	dcBack.BitBlt(210,0,70,70,&dcTile,0,0,SRCCOPY);


	dcTile.BitBlt(0,0,70,70,&dcTemp,matrix[4]*70,0,SRCCOPY);//welche Kachel?
	dcBack.BitBlt(0,70,70,70,&dcTile,0,0,SRCCOPY);//wohin?	

	dcTile.BitBlt(0,0,70,70,&dcTemp,matrix[5]*70,0,SRCCOPY);
	dcBack.BitBlt(70,70,70,70,&dcTile,0,0,SRCCOPY);

	dcTile.BitBlt(0,0,70,70,&dcTemp,matrix[6]*70,0,SRCCOPY);
	dcBack.BitBlt(140,70,70,70,&dcTile,0,0,SRCCOPY);

	dcTile.BitBlt(0,0,70,70,&dcTemp,matrix[7]*70,0,SRCCOPY);
	dcBack.BitBlt(210,70,70,70,&dcTile,0,0,SRCCOPY);


	dcTile.BitBlt(0,0,70,70,&dcTemp,matrix[8]*70,0,SRCCOPY);//welche Kachel?
	dcBack.BitBlt(0,140,70,70,&dcTile,0,0,SRCCOPY);//wohin?	

	dcTile.BitBlt(0,0,70,70,&dcTemp,matrix[9]*70,0,SRCCOPY);
	dcBack.BitBlt(70,140,70,70,&dcTile,0,0,SRCCOPY);

	dcTile.BitBlt(0,0,70,70,&dcTemp,matrix[10]*70,0,SRCCOPY);
	dcBack.BitBlt(140,140,70,70,&dcTile,0,0,SRCCOPY);

	dcTile.BitBlt(0,0,70,70,&dcTemp,matrix[11]*70,0,SRCCOPY);
	dcBack.BitBlt(210,140,70,70,&dcTile,0,0,SRCCOPY);


	dcTile.BitBlt(0,0,70,70,&dcTemp,matrix[12]*70,0,SRCCOPY);//welche Kachel?
	dcBack.BitBlt(0,210,70,70,&dcTile,0,0,SRCCOPY);//wohin?	

	dcTile.BitBlt(0,0,70,70,&dcTemp,matrix[13]*70,0,SRCCOPY);
	dcBack.BitBlt(70,210,70,70,&dcTile,0,0,SRCCOPY);

	dcTile.BitBlt(0,0,70,70,&dcTemp,matrix[14]*70,0,SRCCOPY);
	dcBack.BitBlt(140,210,70,70,&dcTile,0,0,SRCCOPY);

	dcTile.BitBlt(0,0,70,70,&dcTemp,matrix[15]*70,0,SRCCOPY);
	dcBack.BitBlt(210,210,70,70,&dcTile,0,0,SRCCOPY);	
}

void CGrafikWindow::drawCovers()
{			
	CClientDC dc(this);			

	dcTile.BitBlt(0,0,70,70,&dcTemp,8*70,0,SRCCOPY);//die Leer-Kachel	

	if(a1==false)dcBack.BitBlt(0,0,70,70,&dcTile,0,0,SRCCOPY);
	if(a2==false)dcBack.BitBlt(70,0,70,70,&dcTile,0,0,SRCCOPY);	
	if(a3==false)dcBack.BitBlt(140,0,70,70,&dcTile,0,0,SRCCOPY);
	if(a4==false)dcBack.BitBlt(210,0,70,70,&dcTile,0,0,SRCCOPY);
	
	if(b1==false)dcBack.BitBlt(0,70,70,70,&dcTile,0,0,SRCCOPY);	
	if(b2==false)dcBack.BitBlt(70,70,70,70,&dcTile,0,0,SRCCOPY);	
	if(b3==false)dcBack.BitBlt(140,70,70,70,&dcTile,0,0,SRCCOPY);	
	if(b4==false)dcBack.BitBlt(210,70,70,70,&dcTile,0,0,SRCCOPY);
	
	if(c1==false)dcBack.BitBlt(0,140,70,70,&dcTile,0,0,SRCCOPY);	
	if(c2==false)dcBack.BitBlt(70,140,70,70,&dcTile,0,0,SRCCOPY);	
	if(c3==false)dcBack.BitBlt(140,140,70,70,&dcTile,0,0,SRCCOPY);	
	if(c4==false)dcBack.BitBlt(210,140,70,70,&dcTile,0,0,SRCCOPY);
	
	if(d1==false)dcBack.BitBlt(0,210,70,70,&dcTile,0,0,SRCCOPY);	
	if(d2==false)dcBack.BitBlt(70,210,70,70,&dcTile,0,0,SRCCOPY);	
	if(d3==false)dcBack.BitBlt(140,210,70,70,&dcTile,0,0,SRCCOPY);	
	if(d4==false)dcBack.BitBlt(210,210,70,70,&dcTile,0,0,SRCCOPY);

	/////////////Das Wieder-Abdecken falscher Kacheln//////////////////

if(clickSequence==2)
	{									
		clickSequence=3;		
	}

if(clickSequence==3)
{
	if(val1!=val2)	
	{			
		m_Status.SetText("Incorrect",2,0);

		if(m1==1||m2==1)	a1=false;
		if(m1==2||m2==2)	a2=false;
		if(m1==3||m2==3)	a3=false;
		if(m1==4||m2==4)	a4=false;

		if(m1==5||m2==5)	b1=false;
		if(m1==6||m2==6)	b2=false;
		if(m1==7||m2==7)	b3=false;
		if(m1==8||m2==8)	b4=false;

		if(m1==9||m2==9)	c1=false;
		if(m1==10||m2==10)	c2=false;
		if(m1==11||m2==11)	c3=false;
		if(m1==12||m2==12)	c4=false;

		if(m1==13||m2==13)	d1=false;
		if(m1==14||m2==14)	d2=false;
		if(m1==15||m2==15)	d3=false;		
		if(m1==16||m2==16)	d4=false;		
	}	

	else if(val1==val2)	//richtig aufgedeckt
	{	
		m_Status.SetText("Correct",2,0);

		if(m1==1||m2==1)	A1=true;
		if(m1==2||m2==2)	A2=true;
		if(m1==3||m2==3)	A3=true;
		if(m1==4||m2==4)	A4=true;

		if(m1==5||m2==5)	B1=true;
		if(m1==6||m2==6)	B2=true;
		if(m1==7||m2==7)	B3=true;
		if(m1==8||m2==8)	B4=true;

		if(m1==9||m2==9)	C1=true;
		if(m1==10||m2==10)	C2=true;
		if(m1==11||m2==11)	C3=true;
		if(m1==12||m2==12)	C4=true;

		if(m1==13||m2==13)	D1=true;
		if(m1==14||m2==14)	D2=true;
		if(m1==15||m2==15)	D3=true;		
		if(m1==16||m2==16)	D4=true;		

		if(A1==true&&A2==true&&A3==true&&A4==true&&
			B1==true&&B2==true&&B3==true&&B4==true&&
			C1==true&&C2==true&&C3==true&&C4==true&&
			D1==true&&D2==true&&D3==true&&D4==true)

		{
			endgame=true;  //alle Kacheln aufgedeckt; Spielende
		}
	}	
}
//////////////////////////////////////////////////////////
}

void CGrafikWindow::drawGraphics()
{			
	CClientDC dc(this);	
	
	if(endgame==true)
	{
		endSequence();		
	}

	else
	{
		drawTiles();

	if(clickSequence==3)
	{		
		Sleep(500);	
		clickSequence=0;
	}	

	drawCovers();
	if(mousedown==false)
		drawHighlights();	
	
	if(intro==true)
	{		
		drawTitle();				
	}
	else
	
	dc.BitBlt(0,0,280,280,&dcBack,0,0,SRCCOPY);		
	}

	/////////////////////////////

	if(mousedown==true)
	{
	char err[11];
	
	_itoa( errors, err, 10 );
	CString errStr("Move ");
	errStr+=err;
	if(errors>0)
		m_Status.SetText(errStr,0,0);
	else if(klicked==false)
		m_Status.SetText("New Game",0,0);
	else
		m_Status.SetText("",0,0);
	}

	//////////////////////////////		
}

void CGrafikWindow::endSequence()
{
	klicked=false;
	m_Status.SetText("",0,0);

	CClientDC dc(this);

	if(endgame==true)Sleep(1000);	

	for(int i=0;i<10;i++)
	{
	initializeNewGame();		
	drawTiles();
	Sleep(100);	
	dc.BitBlt(0,0,280,280,&dcBack,0,0,SRCCOPY);
	}
	endgame=false;
	initializeNewGame();

	if(shuffle==true)design++;
	if(design>9)design=1;

	switch(design)
	{
	case 1:OnColors();break;
		case 2:OnAnimals();break;
			case 3:OnTraffic();break;
				case 4:OnSigns();break;
					case 5:OnOriental();break;
						case 6:OnChristmas();break;
							case 7:OnObjects();break;
								case 8:OnCartoons();break;
									case 9:OnFruits();break;
	}
}

void CGrafikWindow::createStatusBar()
{			
	RECT r;
	int i;
	int parts[3];
	GetClientRect(&r);
	for(i=1; i<4; i++)
		parts[i-1] = r.right/3 *i;

	r.left=r.top=r.right=r.bottom=0;	
	m_Status.Create(WS_VISIBLE | WS_CHILD | CCS_TOP | CCS_BOTTOM,
		r, this, IDD_STATUS);
	m_Status.SetParts(3, parts);		
}

CGrafikWindow::CGrafikWindow(LPCSTR ClassName)   
{
	int width=290;	//Die Fenstergre 
	int height=360;	//348  
    int xoffset=(::GetSystemMetrics(SM_CXSCREEN) - width) / 2; //zentrieren
	int yoffset=(::GetSystemMetrics(SM_CYSCREEN) - height) / 2;

	Create(ClassName,"Concentration Game",
		WS_OVERLAPPED|WS_SYSMENU|WS_MINIMIZEBOX,
		CRect(xoffset,yoffset,xoffset+width,yoffset+height)
		,NULL,"MAINMENUE");	
    
	CClientDC dc(this);
	dcBack.CreateCompatibleDC(&dc);
	dcTile.CreateCompatibleDC(&dc);
	dcTemp.CreateCompatibleDC(&dc);
	dcTitle.CreateCompatibleDC(&dc);

	backbmp.CreateCompatibleBitmap(&dc, 280, 280);
	titlebmp.CreateCompatibleBitmap(&dc, 280, 306);
	tilebmp.CreateCompatibleBitmap(&dc, 70, 70);
	tempbmp.CreateCompatibleBitmap(&dc, 630, 70);
	dcBack.SelectObject(&backbmp);
	dcTile.SelectObject(&tilebmp);
	dcTemp.SelectObject(&tempbmp);
	dcTitle.SelectObject(&titlebmp);

	strip[0].LoadBitmap(IDB_COLORS);	
	strip[1].LoadBitmap(IDB_ANIMALS);	
	strip[2].LoadBitmap(IDB_VEHICLES);	
	strip[3].LoadBitmap(IDB_SIGNS);	
	strip[4].LoadBitmap(IDB_ORIENTAL);	
	strip[5].LoadBitmap(IDB_CHRISTMAS);	
	strip[6].LoadBitmap(IDB_OBJECTS);	
	strip[7].LoadBitmap(IDB_CARTOONS);	
	strip[8].LoadBitmap(IDB_FRUITS);
	
	title.LoadBitmap(IDB_TITLE);	

	CMenu *m_MainMenu = GetMenu();	
	m_MainMenu->CheckMenuItem( ID_OPTIONS_COLORS, MF_CHECKED );
	m_MainMenu->CheckMenuItem( ID_OPTIONS_SHUFFLE, MF_CHECKED );

	dcTitle.SelectObject(&title);

	dcTemp.SelectObject(&strip[0]);
	
	redPen.CreatePen(PS_DOT,1,RGB(255,0,0));
	nullBrush.CreateStockObject(NULL_BRUSH);

	srand( (unsigned)time( NULL ) );//Initialisierung Zufallsgenerator	
	
	SetTimer(IDT_TIMER1,50,NULL);
	createStatusBar();
	m_Status.SetText("New Game",0,0);

	createMatrix();
	createMatrix();

	clickSequence=0;
	errors=0;
	endgame=false;
	mousedown=false;
	shuffle=true;
	design=1;
	klicked=false;
	intro=true;

	a1=a2=a3=a4=b1=b2=b3=b4=c1=c2=c3=c4=d1=d2=d3=d4=false;
	A1=A2=A3=A4=B1=B2=B3=B4=C1=C2=C3=C4=D1=D2=D3=D4=false;

	val1=val2=m1=m2=hilite=-1;	
	
	CGrafikApp* cgApp = (CGrafikApp*)AfxGetApp();
    cgApp->cgw = this;
}


CGrafikApp GrafikApp;
