//memory.h

#define IDM_QUIT                        101
#define IDM_HELP                        102
#define IDT_TIMER1						200
#define IDD_STATUS                      300
#define IDD_HELPTEXT					400

class CGrafikApp : public CWinApp
{
	public:
	CGrafikApp();
public:
virtual BOOL InitInstance();

private:
	friend class CGrafikWindow;
	CGrafikWindow* cgw;
};

class CGrafikWindow : public  CFrameWnd
{

public:
CGrafikWindow(LPCSTR ClassName);
void drawGraphics();
void drawTiles();
void drawCovers();
void drawHighlights();
void drawTitle();
void initializeNewGame();
void endSequence();
void createMatrix();
void createStatusBar();
virtual ~CGrafikWindow();

private:
afx_msg void OnLButtonDown(UINT nFlags, CPoint point );
afx_msg void OnLButtonUp(UINT nFlags, CPoint point );
afx_msg void OnRButtonDown(UINT nFlags, CPoint point );
afx_msg void OnMouseMove( UINT nFlags, CPoint point );
afx_msg void OnTimer(UINT nIDEvent);
afx_msg void OnAbout();
afx_msg void OnTutorial();
afx_msg void OnNewGame();
afx_msg void OnQuit();
afx_msg void OnPaint();
afx_msg void OnAnimals();
afx_msg void OnTraffic();
afx_msg void OnColors();
afx_msg void OnSigns();
afx_msg void OnCartoons();
afx_msg void OnChristmas();
afx_msg void OnOriental();
afx_msg void OnObjects();
afx_msg void OnFruits();
afx_msg void OnShuffle();

CDC dcBack, dcTile, dcTemp, dcTitle;
CBitmap backbmp, tilebmp, tempbmp, titlebmp;

CBitmap strip[9], title;

CStatusBarCtrl m_Status;	

int matrix[16];
int clickSequence;
bool a1,a2,a3,a4,b1,b2,b3,b4,c1,c2,c3,c4,d1,d2,d3,d4;
bool A1,A2,A3,A4,B1,B2,B3,B4,C1,C2,C3,C4,D1,D2,D3,D4;
int val1, val2, m1, m2, hilite, errors, design;
bool endgame, mousedown, shuffle, klicked, intro;

CPen redPen;
CBrush nullBrush;

DECLARE_MESSAGE_MAP()
};




